package com.vance.informit.race;

import org.apache.log4j.Logger;

import java.util.Vector;

public class AuditRace {
    private static final Logger log = Logger.getLogger(AuditRace.class);
    private final Vector<AuditRecord> logRecords = new Vector<AuditRecord>();

    public void postFlush() {
        while (!logRecords.isEmpty()) {
            log.debug("Processing log record");
            AuditRecord logRecord;
            synchronized (logRecords) {
                // Uncomment this to fix the race
//                if (logRecords.isEmpty()) {
//                    break;
//                }
                logRecord = logRecords.firstElement();
                logRecords.remove(logRecord);
            }
        }
    }

    public void addRecord() {
        logRecords.add(new AuditRecord());
    }

    /**
     * ONLY FOR TESTING
     */
    protected Vector<AuditRecord> getLogRecords() {
        return logRecords;
    }
}

class AuditRecord {

};
